function r=pile_ou_face()
r=rand(1);
if r>1/2 then 
    r=1;
else
    r=-1;
end
endfunction

function position=marche_aleatoire(N) 
position=zeros(N,1);
position(1)=0;//(condition initiale) pas necessarie 
for i=2:N
    position(i)=position(i-1)+pile_ou_face();       
end   
endfunction

function [minx,maxx]=min_max(x) 
minx=min(x);
maxx=max(x);
endfunction


function position=run_upto_condition() 
//marche aleatoire avec condition de terminaison 
maxit=1e4
max_abs=30;
position=zeros(maxit,1);
position(1)=0;//(condition initiale) pas necessarie 
for i=2:maxit
    //disp(i)
    position(i)=position(i-1)+pile_ou_face(); 
    if abs(position(i))>=max_abs
        position=position(1:i);
        break;
    end          
end   
endfunction

function [minx,maxx]=min_max(x) 
minx=min(x);
maxx=max(x);
endfunction

function r=bussole()
r1=pile_ou_face();r2=pile_ou_face();
//nous devons écrire une fonction telle que les quatre options aient la même probabilité. 
//Voici l'une des nombreuses possibilités pour y parvenir
r=[r1,r2];
Rot=[1/2,-1/2;1/2,1/2];
r=(r*Rot);
endfunction

function [X,Y]=marche_aleatoire2D(N) 
X=zeros(N,1);
Y=zeros(N,1);
for i=2:N
    r=bussole();
    X(i)=X(i-1)+r(1); 
    Y(i)=Y(i-1)+r(2);         
end   
endfunction


// EXERCISE 3
function r=pile_ou_face_gen(p)
//p=probabilite que r=-1, 0<p<1
r=rand(1);
if r>p then 
    r=1;
else
    r=-1;
end
endfunction

function r=bussole_gen(ps)
//p=probabilite que r=[-1,0]
//q=probabilite que r=[ 1,0]
//t=probabilite que r=[0,-1]
//1-p-q-t=probabilite que r=[0,1]
r=rand(1);
p=ps(1)
q=ps(2)
t=ps(3)
if r<=p
    r=[-1,0]
else
    if r<=p+q
        r=[1,0]
    else
        if r<=p+q+t
            r=[0,-1]
        else
            r=[0,1]
        end
    end
end
endfunction


function [X,Y]=marche_aleatoire2D_gen(N,drift,ps) 
//drift=vitesse constante
X=zeros(N,1);
Y=zeros(N,1);
for i=2:N
    r=bussole_gen(ps);
    X(i)=X(i-1)+r(1)+drift(1); 
    Y(i)=Y(i-1)+r(2)+drift(2);         
end   
endfunction


function [distX2]=fonction_dist(XX,X0)
distX2 = sqrt( max( (XX(:,1)-X0(1)).^2 + (XX(:,2)-X0(2)).^2 ) );   
endfunction
